<template>
    <form @submit.prevent="onSubmit">
        <div class="container">
            <div class="card shadow mb-4">
                <div
                    class="d-flex flex-wrap card-header py-3 justify-content-between align-items-center"
                >
                    <div class="d-none d-md-block">
                        <a
                            @click="$router.go(-1)"
                            class="btn btn-primary"
                            role="button"
                            >Back</a
                        >
                    </div>
                    <div class="text-md-center">
                        <h3 class="m-0 font-weight-bold text-primary">
                            {{ title }}
                        </h3>
                    </div>
                    <div class="text-right">
                        <input
                            :class="{
                                invisible: this.$route.name == 'ProjectShow'
                            }"
                            class="btn btn-success"
                            type="submit"
                            value="SAVE"
                            :disabled="this.isSubmit"
                        />
                    </div>
                </div>
                <div class="card-body">
                    <div class="row">
                        <div class="col-12 col-md-8">
                            <div class="row">
                                <div class="col-12 col-md-6">
                                    <div class="form-group">
                                        <label for="inputProjectName"
                                            >Project Name</label
                                        >
                                        <input
                                            type="text"
                                            id="inputProjectName"
                                            class="form-control"
                                            v-model="dataProject.name"
                                            required
                                            :readonly="isDisabled"
                                        />
                                    </div>
                                </div>
                                <div class="col-12 col-md-6">
                                    <div class="form-group">
                                        <label for="inputLocation"
                                            >Location</label
                                        >
                                        <input
                                            type="text"
                                            id="inputLocation"
                                            class="form-control"
                                            v-model="dataProject.location"
                                            required
                                            :readonly="isDisabled"
                                        />
                                    </div>
                                </div>
                                <div class="col-12 col-md-6">
                                    <label for="inputInstalled_at"
                                        >Installed At</label
                                    >
                                    <b-date-picker
                                        v-model="dataProject.installed_at"
                                        :events="installedEvents"
                                        :max="dataProject.dismantle_at"
                                        :disabled="isDisabled"
                                    ></b-date-picker>
                                </div>
                                <div class="col-12 col-md-6">
                                    <label for="inputDismantle_at"
                                        >Dismantle At</label
                                    >

                                    <b-date-picker
                                        v-model="dataProject.dismantle_at"
                                        :events="dismantleEvents"
                                        :min="dataProject.installed_at"
                                        :disabled="isDisabled"
                                    ></b-date-picker>
                                </div>
                                <div class="col-12 col-md-6">
                                    <div class="form-group">
                                        <label for="selectStatus">Status</label>
                                        <multi-select
                                            v-model="dataProject.status"
                                            :options="this.taskList"
                                            placeholder="Select Status"
                                            :disabled="isDisabled"
                                        ></multi-select>
                                    </div>
                                </div>
                                <div class="col-12 col-md-6">
                                    <div class="form-group">
                                        <label for="selectOwner">Owner</label>
                                        <multi-select
                                            v-model="dataProject.owner"
                                            :options="users"
                                            track-by="id"
                                            label="full_name"
                                            placeholder="Select Owner"
                                            @select="onSelectOwner"
                                            :disabled="isDisabled"
                                        ></multi-select>
                                    </div>
                                </div>
                                <div class="col-12">
                                    <div class="form-group">
                                        <label for="selectEmployees"
                                            >Employees</label
                                        >
                                        <multi-select
                                            v-model="dataProject.employees"
                                            :options="filterEmployees"
                                            :multiple="true"
                                            track-by="id"
                                            label="full_name"
                                            placeholder="Select Employee"
                                            :disabled="isDisabled"
                                        >
                                        </multi-select>
                                    </div>
                                </div>
                            </div>
                            <div class="col-12 my-3">
                                <div class="form-group">
                                    <progress-bar
                                        :percentage="taskProgress"
                                    ></progress-bar>
                                </div>
                            </div>
                        </div>
                        <div class="col-12 col-md-4">
                            <task-list
                                @addTodoList="addTodoList"
                                @deleteTask="deleteTask"
                                :tasks="dataProject.tasks"
                                :disabled="isDisabled"
                            ></task-list>
                        </div>
                    </div>
                </div>
                <div class="card-footer">
                    <calendar-search v-model="dataProject"></calendar-search>
                </div>
            </div>
        </div>
    </form>
</template>

<script>
import Swal from "sweetalert2";
import TaskList from "../TaskListComponent";
import ProgressBar from "../ProgressBarComponent";
import MultiSelect from "vue-multiselect";
import BDatePicker from "../DatePickerComponent";
import CalendarSearch from "../CalendarSearchComponent.vue";

var taskList = [
    "Planning",
    "Designing",
    "Purchasing",
    "Production",
    "Installing",
    "Demantle",
    "Finished"
];

export default {
    components: {
        TaskList,
        ProgressBar,
        MultiSelect,
        BDatePicker,
        CalendarSearch
    },
    props: {
        project: {},
        backUrl: "",
        saveUrl: "",
        title: { default: "Project" }
    },
    data() {
        return {
            isSubmit: false,
            dataProject: {
                name: "",
                location: "",
                installed_at: new Date().toISOString().slice(0, 10),
                dismantle_at: new Date().toISOString().slice(0, 10),
                status: "",
                owner: [],
                employees: [],
                tasks: []
            },
            menuInstalled: false,
            menuDismantle: false,
            users: [],
            projects: [],
            isDisabled: this.$route.name == "ProjectShow"
        };
    },
    created() {
        this.prepare();
    },
    methods: {
        prepare() {
            if (this.project) {
                this.dataProject = this.project;
            } else if (this.$route.params.id) {
                this.getProject(this.$route.params.id);
            } else {
                taskList.forEach(task => {
                    this.dataProject.tasks.push({
                        name: task,
                        completed: false
                    });
                });
            }

            this.getUsers();
            this.getProjects();
        },
        getUsers() {
            axios
                .get("/api/user/all")
                .then(res => {
                    this.users = res.data;
                })
                .catch(err => {
                    console.log(err.message);
                });
        },
        getProject(id) {
            axios
                .get("/api/project/get/" + id)
                .then(res => {
                    this.dataProject = res.data;
                })
                .catch(err => {
                    console.warn(err.message);
                });
        },
        getProjects() {
            axios
                .get("/api/project/all")
                .then(res => {
                    this.projects = res.data;
                })
                .catch(err => {
                    console.log(err.message);
                });
        },
        addTodoList(tasks) {
            this.dataProject.tasks = tasks;
        },
        deleteTask(taskName) {
            if (this.dataProject.status == taskName) {
                this.dataProject.status = null;
            }
        },
        taskCompleted(isCompleted) {
            return this.dataProject.tasks.filter(
                task => task.completed == isCompleted
            );
        },
        onSubmit() {
            this.isSubmit = true;
            if (this.$route.name == "ProjectCreate") {
                axios
                    .post("/project", this.dataProject)
                    .then(res => {
                        Swal.fire("Saved!", "", "success").then(result => {
                            this.$router.push({
                                name: "ProjectIndex"
                            });
                        });
                    })
                    .catch(err => {
                        console.warn(err.response.data.errors);
                        Swal.fire("Error!", err.response.data.message, "error");
                    })
                    .then(res => {
                        this.isSubmit = false;
                    });
            } else if (this.$route.name == "ProjectEdit") {
                axios
                    .put("/project/" + this.dataProject.id, this.dataProject)
                    .then(res => {
                        Swal.fire("Updated!", "", "success").then(result => {
                            this.$router.push({
                                name: "ProjectIndex"
                            });
                        });
                    })
                    .catch(err => {
                        console.warn(err.response.data.errors);
                        Swal.fire("Error!", err.response.data.message, "error");
                    })
                    .then(res => {
                        this.isSubmit = false;
                    });
            }
        },
        onSelectOwner(selectedOption) {
            this.dataProject.employees = _.reject(
                this.dataProject.employees,
                function(user) {
                    return user.id == selectedOption.id;
                }
            );
        }
    },
    computed: {
        taskProgress() {
            return (
                (this.taskCompleted(true).length * 100) /
                this.dataProject.tasks.length
            );
        },
        taskList() {
            return _.map(this.dataProject.tasks, "name");
        },
        installedEvents() {
            return _.map(this.projects, "installed_at");
        },
        dismantleEvents() {
            return _.map(this.projects, "dismantle_at");
        },
        filterEmployees() {
            if (this.dataProject.owner) {
                return _.reject(
                    this.users,
                    function(user) {
                        return user.id == this.dataProject.owner.id;
                    }.bind(this)
                );
            } else {
                return this.users;
            }
        }
    }
};
</script>
